/* load external functions */
Call RxFuncAdd 'ExpatLoadFuncs', 'RexxExpat', 'ExpatLoadFuncs'; 
/* load RexxExpat */
/* Say 	ExpatLoadFuncs(); */
Call 	ExpatLoadFuncs;
/* create parser */
Parser = ExpatParserCreate();
Say 	Parser;
/* set handlers */
Call	ExpatSetElementHandler(Parser, "StartElement.cmd", "", 0, "EndElement.cmd", "", 0);
/* set global variables */
padding 	= 5
i	= 0

/* parse file */
myfile	= "RexxExpatExample.xml"
mypos	= 0
do while lines(myfile)<>0
	/* for each line */
	nextline	= linein(myfile)
	/* remember file offset */
	mypos 	= STREAM(myfile, 'Command', 'Query Position Read'); 
	/* free variable pool */
 	Call	ExpatFreeVariablePool(Parser);
	/* set variable pool */
 	Call	ExpatSetVariablePool(Parser, "i", "padding");
	/* parse */
	retstr 	= ExpatParse(Parser, nextline, lines(myfile))
	/* get variable pool */
 	Call	ExpatGetVariablePool(Parser); 
	if retstr 	== 0 then do
		say "### ERROR ###"
		call pos_n_err_funcs;
		end;
	/* restore file offset */
	Call	STREAM(myfile, 'Command', 'Position ='mypos Read);
end

/* free ressources */
Say ExpatParserFree(Parser);
Say ExpatDropFuncs();

/* bye */
return 0
exit

/********************/
pos_n_err_funcs:
say	"Parse Position and Error Reporting Functions:"
errno 	= ExpatGetErrorCode(Parser);
errstr 	= ExpatErrorString(errno);
byteno 	= ExpatGetCurrentByteIndex(Parser);
lineno 	= ExpatGetCurrentLineNumber(Parser); 
colno	= ExpatGetCurrentColumnNumber(Parser);
say	"GetErrorCode: '"errno"' ErrorString: '"errstr"' CurrentByteIndex: '"byteno"' CurrentLineNumber: '"lineno"' CurrentColumnNumber: '"colno"'"
return

/********************/
misc_funcs:
say	"Miscellaneous Functions:"
rc1 =	ExpatSetBase(Parser, "\meine Homepage");
Base = 	ExpatGetBase(Parser);
Count =	ExpatGetSpecifiedAttributeCount(Parser); 
Index =	ExpatGetIdAttributeIndex(Parser);
rc2 =	ExpatSetEncoding(Parser, ENCODING);
rc3 =	ExpatSetParamEntityParsing(Parser, "xml_param_endtity_parsing_never");
say	"SetBase: '"rc1"' GetBase: '"Base"' GetSpecifiedAttribute: '"Count"' GetIdAttributeIndex: '"Index"' SetEncoding: '"rc2"' SetParamEntityParsing: '"rc3"'"
return
