/* load external functions */
Call RxFuncAdd 'ExpatLoadFuncs', 'RexxExpat.dll', 'ExpatLoadFuncs'; 

/* load RexxExpat */
Say 	ExpatLoadFuncs();
/* create parser */
Parser = ExpatParserCreate();
/* set handlers */
/* Call	ExpatSetElementHandler(Parser, "Say 'StartElement <'ARG(2)'>';", "", 3, "Say 'EndElement <'ARG(2)'>';", "", 3); */
Call	ExpatSetElementHandler(Parser, "ExternalFunction.rexx", "", 0, "ExternalFunction.rexx", "", 0);
Call 	ExpatSetCharacterDataHandler(Parser, "Say 'CharacterData <'ARG(2)'>';", "", 3);
Call 	ExpatSetProcessingInstructionHandler(Parser, "Say 'Processing Instruction <target: 'ARG(2)' data: 'ARG(3)'>';", "", 3);
Call 	ExpatSetCommentHandler(Parser, "Say 'Comment <'ARG(2)'>';", "", 3);
Call 	ExpatSetDoctypeDeclHandler(Parser, "Say 'StartDoctypeDecl <'ARG(2)'>';", "", 3, "Say 'EndDoctypeDecl';", "", 3);
Call 	ExpatSetCDATASectionHandler(Parser, "Say 'StartCDATASection';", "", 3, "Say 'EndCDATASection';", "", 3);
Call 	ExpatSetDefaultHandler(Parser, "Say 'Default <'ARG(2)'>';", "", 3);
Call 	ExpatSetDefaultHandlerExpand(Parser, "Say 'DefaultExpand <'ARG(2)'>';", "", 3);
Call 	ExpatSetExternalEntityRefHandler(Parser, "Say 'ExternalEntity <context: 'ARG(2)' base: 'ARG(3)' systemID: 'ARG(4)' publicID: 'ARG(5)'>';", "", 3);
Call 	ExpatSetUnknownEncodingHandler(Parser, "Say 'UnknownEncoding <'ARG(2)'>'; Return '//////////10//////////20//////////30//////-3////40//////////50//////////60//////////70//////////80//////////90//////////100//////////110//////////120//////////130/-2/4/-2/5/255/'", "", 3);
Call 	ExpatSetUnknownEncodingConverter(Parser, "Say 'Convert <'ARG(2)'>'; Return 64;", "", 3, "Say 'Release';", "", 3); 
Call 	ExpatSetNamespaceDeclHandler(Parser, "Say 'StartNamespace <prefix: 'ARG(2)' uri: 'ARG(3)'>';", "", 3, "Say 'EndNamespace <'ARG(2)'>';", "", 3);
Call 	ExpatSetUnparsedEntityDeclHandler(Parser, "Say 'UnparsedEntity <name: 'ARG(2)' base: 'ARG(3)' systemID: 'ARG(4)' publicID: 'ARG(5)' notation: 'ARG(6)'>';", "", 3);
Call 	ExpatSetExternalParsedEntityDeclHandler(Parser, "Say 'ExternalParsedEntity <name: 'ARG(2)' base: 'ARG(3)' systemID: 'ARG(4)' publicID: 'ARG(5)'>';", "", 3);
Call 	ExpatSetInternalParsedEntityDeclHandler(Parser, "Say 'InternalParsedEntity <name: 'ARG(2)' replacementText: 'ARG(3)'>';", "", 3);
Call 	ExpatSetNotationDeclHandler(Parser, "Say 'Notation <name: 'ARG(2)' base: 'ARG(3)' systemID: 'ARG(4)' publicID: 'ARG(5)'>';", "", 3);
Call 	ExpatSetNotStandaloneHandler(Parser, "Say 'NotStandalone';", "", 3);

/* set encoding */
/* ENCODING = "oha";
Call 	misc_funcs */

/* parse file */
myfile	= "Interface.xml"
mypos	= 0
i	= 0
do while lines(myfile)<>0
	/* for each line */
	nextline	= linein(myfile)
	/* remember file offset */
	mypos 	= STREAM(myfile, 'Command', 'Query Position Read'); 

 	Say 	"line number: '"i"', last line? '"lines(myfile)"', file offset: '"mypos"', line '"nextline"'"
/* 	Call	"flush stdout: " STREAM('stdout', 'Command', 'Flush'); */

 	Call	ExpatFreeVariablePool(Parser); 
 	Call	ExpatSetVariablePool(Parser, "mypos", "i");
/* 	Call	ExpatSetVariablePool(Parser); */
	retstr 	= ExpatParse(Parser, nextline, lines(myfile))
/* 	Say 	"i: '"i */
 	Call	ExpatGetVariablePool(Parser); 
/* 	Say 	"i: '"i */
	if retstr 	== 0 then do
		say "### ERROR ###"
		call pos_n_err_funcs;
		end;

	/* restore file offset */
	Call	STREAM(myfile, 'Command', 'Position ='mypos Read); 
	i 	= i + 1
end

/* free ressources */
Say ExpatParserFree(Parser);
Say ExpatDropFuncs();

/* bye */
return 0
exit

/********************/
pos_n_err_funcs:
say	"Parse Position and Error Reporting Functions:"
errno 	= ExpatGetErrorCode(Parser);
errstr 	= ExpatErrorString(errno);
byteno 	= ExpatGetCurrentByteIndex(Parser);
lineno 	= ExpatGetCurrentLineNumber(Parser); 
colno	= ExpatGetCurrentColumnNumber(Parser);
say	"GetErrorCode: '"errno"' ErrorString: '"errstr"' CurrentByteIndex: '"byteno"' CurrentLineNumber: '"lineno"' CurrentColumnNumber: '"colno"'"
return

/********************/
misc_funcs:
say	"Miscellaneous Functions:"
rc1 =	ExpatSetBase(Parser, "\meine Homepage");
Base = 	ExpatGetBase(Parser);
Count =	ExpatGetSpecifiedAttributeCount(Parser); 
Index =	ExpatGetIdAttributeIndex(Parser);
rc2 =	ExpatSetEncoding(Parser, ENCODING);
rc3 =	ExpatSetParamEntityParsing(Parser, "xml_param_endtity_parsing_never");
say	"SetBase: '"rc1"' GetBase: '"Base"' GetSpecifiedAttribute: '"Count"' GetIdAttributeIndex: '"Index"' SetEncoding: '"rc2"' SetParamEntityParsing: '"rc3"'"
return
